#ifndef VGOLF_UTILITY_H
#define VGOLF_UTILITY_H

#include "t3f/t3f.h"
#include "t3f/animation.h"
#include "poly.h"
#include "body.h"
#include "pcx.h"

T3F_ANIMATION * vgolf_bitmap_to_animation(ALLEGRO_BITMAP * bp);
float vgolf_get_bitmap_width(T3F_ANIMATION * ap);
float vgolf_get_bitmap_height(T3F_ANIMATION * ap);
char * vgolf_get_date_string(void);
const char * vgolf_select_file(const char * initial, const char * title);
void vgolf_srand(unsigned int seed);
int vgolf_rand(void);
double vgolf_drand(void);

int line_circle_collide(float cx, float cy, float cr, float x1, float y1, float x2, float y2);
char poly_is_empty(POLY po);
char poly_is_laser(POLY po);
char check_body_collision(BODY * a, BODY * b);
char circle_lineseg_rect_collision(VERTEX b_c, float radius, VERTEX v1, VERTEX v2, VERTEX c);
void draw_polygon(POLY po, int cx, int cy, float ox, float oy, float zoom, ALLEGRO_COLOR color);
void draw_filled_polygon(POLY po, float cx, float cy, float ox, float oy, float zoom, ALLEGRO_COLOR color);
ALLEGRO_COLOR get_color(PALETTE * palette, int color);

int for_each_file_ex(const char * name, int in_attrib, int out_attrib, int (*callback)(const char * filename, int attrib, void * param), void * param);

#endif
