#include <stdio.h>
#include "ui_handle.h"

static CRSED_HANDLE ui_handle[256];
static int ui_handles = 0;
static float ui_handle_mouse_x;
static float ui_handle_mouse_y;
static int ui_handle_mouse_button = 0;
static int ui_hover_handle = -1;
static int ui_selected_handle = -1;;
static float ui_handle_peg_x;
static float ui_handle_peg_y;
static int ui_handle_dragging = 0;
static int ui_handle_click_tick = 0;

void crsed_clear_handles(void)
{
    ui_handles = 0;
}

CRSED_HANDLE * crsed_add_handle(float size, float * x, float * y, float * r, void (*callback)(CRSED_HANDLE * handle, void * data), void * data)
{
    CRSED_HANDLE * ret = NULL;

    if(ui_handles < 256)
    {
        ui_handle[ui_handles].size = size;
        ui_handle[ui_handles].x = x;
        ui_handle[ui_handles].y = y;
        ui_handle[ui_handles].r = r;
        ui_handle[ui_handles].link_x = NULL;
        ui_handle[ui_handles].link_y = NULL;
        ui_handle[ui_handles].link_r = NULL;
        ui_handle[ui_handles].callback = callback;
        ui_handle[ui_handles].data = data;
        ret = &ui_handle[ui_handles];
        ui_handles++;
    }
    return ret;
}

void crsed_link_handle(CRSED_HANDLE * hp, float * x, float * y, float * r)
{
    hp->link_x = x;
    hp->link_y = y;
    hp->link_r = r;
}

void crsed_update_handle_input(float x, float y, int b)
{
    ui_handle_mouse_x = x;
    ui_handle_mouse_y = y;
    ui_handle_mouse_button = b;
}

void crsed_handle_logic(int flags)
{
    int i;

    if(!ui_handle_mouse_button)
    {
        ui_handle_dragging = -1;
        ui_handle_click_tick = 0;
    }
    ui_hover_handle = -1;
    for(i = 0; i < ui_handles; i++)
    {
        if(ui_handle_mouse_x >= *ui_handle[i].x - ui_handle[i].size &&
           ui_handle_mouse_x <= *ui_handle[i].x + ui_handle[i].size &&
           ui_handle_mouse_y >= *ui_handle[i].y - ui_handle[i].size &&
           ui_handle_mouse_y <= *ui_handle[i].y + ui_handle[i].size)
        {
            if(ui_handle_dragging < 0)
            {
                ui_handle_peg_x = ui_handle_mouse_x - *ui_handle[i].x;
                ui_handle_peg_y = ui_handle_mouse_y - *ui_handle[i].y;
            }
            ui_hover_handle = i;
//            crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
        }
    }
    if(ui_hover_handle < 0 && !ui_handle_dragging)
    {
//        crsed_set_cursor(data, ALLEGRO_SYSTEM_MOUSE_CURSOR_DEFAULT);
    }

    if(!flags)
    {
        if(ui_handle_dragging >= 0)
        {
            if(ui_handle_mouse_button)
            {
                *ui_handle[ui_handle_dragging].x = ui_handle_mouse_x - ui_handle_peg_x;
                *ui_handle[ui_handle_dragging].y = ui_handle_mouse_y - ui_handle_peg_y;
                if(ui_handle[ui_handle_dragging].callback)
                {
                    ui_handle[ui_handle_dragging].callback(&ui_handle[ui_handle_dragging], ui_handle[ui_handle_dragging].data);
                }
                if(ui_handle[ui_handle_dragging].link_x)
                {
                    *ui_handle[ui_handle_dragging].link_x = *ui_handle[ui_handle_dragging].x;
                }
                if(ui_handle[ui_handle_dragging].link_y)
                {
                    *ui_handle[ui_handle_dragging].link_y = *ui_handle[ui_handle_dragging].y;
                }
                if(ui_handle[ui_handle_dragging].link_r)
                {
                    *ui_handle[ui_handle_dragging].link_r = *ui_handle[ui_handle_dragging].r;
                }
            }
        }
        else if(ui_handle_mouse_button)
        {
            ui_handle_click_tick++;
            if(ui_handle_click_tick == 1)
            {
                ui_handle_dragging = ui_hover_handle;
            }
        }
    }
}

int crsed_get_num_handles(void)
{
    return ui_handles;
}

int crsed_get_hover_handle(void)
{
    return ui_hover_handle;
}

CRSED_HANDLE * crsed_get_handle(int handle)
{
    if(handle < ui_handles)
    {
        return &ui_handle[handle];
    }
    return NULL;
}
