#ifndef CRSED_UI_HANDLE_H
#define CRSED_UI_HANDLE_H

typedef struct CRSED_HANDLE
{

    float * x;
    float * y;
    float * r;
    float * link_x;
    float * link_y;
    float * link_r;
    void (*callback)(struct CRSED_HANDLE * handle, void * data);
    void * data;

    float size;
    int i;

} CRSED_HANDLE;

void crsed_clear_handles(void);
CRSED_HANDLE * crsed_add_handle(float size, float * x, float * y, float * r, void (*callback)(CRSED_HANDLE * handle, void * data), void * data);
void crsed_link_handle(CRSED_HANDLE * hp, float * x, float * y, float * r);
void crsed_update_handle_input(float x, float y, int b);
void crsed_handle_logic(int flags);

int crsed_get_num_handles(void);
int crsed_get_hover_handle(void);
CRSED_HANDLE * crsed_get_handle(int handle);

#endif
