#ifndef APP_INSTANCE_H
#define APP_INSTANCE_H

#include "core/course.h"
#include "t3gui/t3gui.h"
#include "t3gui/element.h"

/* structure to hold all of our app-specific data */
typedef struct
{
	/* UI data */
	ALLEGRO_MENU * file_menu;
	ALLEGRO_MENU * hole_select_menu;
	ALLEGRO_MENU * hole_layer_menu;
	ALLEGRO_MENU * hole_menu;
	ALLEGRO_MENU * mode_menu;
	ALLEGRO_MENU * object_type_menu;
	ALLEGRO_MENU * poly_menu;
	ALLEGRO_MENU * object_properties_menu;
	ALLEGRO_MENU * object_menu;
	ALLEGRO_MENU * image_type_end_menu;
	ALLEGRO_MENU * image_type_object_menu;
	ALLEGRO_MENU * image_type_menu;
	ALLEGRO_MENU * image_menu;
	ALLEGRO_MENU * music_menu;
	ALLEGRO_MENU * help_menu;
	ALLEGRO_MENU * main_menu;
    T3GUI_DIALOG * palette_dialog;
    ALLEGRO_BITMAP * palette_bitmap;
	T3GUI_DIALOG * type_dialog;
    T3GUI_DIALOG * timer_dialog;
	T3GUI_DIALOG * timer2_dialog;
    T3GUI_DIALOG * speed_dialog;
    T3GUI_DIALOG * speed2_dialog;
    T3GUI_DIALOG * tags_dialog;
    T3GUI_DIALOG * direction_dialog;
    T3GUI_DIALOG * size_dialog;
    T3GUI_DIALOG * layer_dialog;
	T3GUI_DIALOG * target_layer_dialog;
    T3GUI_DIALOG * par_dialog;
	T3GUI_DIALOG * unsaved_dialog;
	T3GUI_DIALOG * about_dialog;
    int hole_menu_id[18];
	int layer_menu_id[3];
    int mode_menu_id[4];
	int image_menu_id[29];
	int object_menu_id[39];
	int object_properties_menu_id[16];
	int menu_save_id;
	int menu_save_as_id;
	int menu_tags_id;
	T3GUI_THEME * button_theme;
	T3GUI_THEME * text_box_theme;
	T3GUI_THEME * asset_theme;
	char tags_title[256];
	char tags_author[256];
	char tags_comment[1024];
	const T3GUI_ELEMENT * tags_ok_element;
	const T3GUI_ELEMENT * type_list_element;
	const T3GUI_ELEMENT * layer_ok_element;
	const T3GUI_ELEMENT * target_layer_ok_element;
	const T3GUI_ELEMENT * direction_ok_element;
	const T3GUI_ELEMENT * size_ok_element;
	const T3GUI_ELEMENT * speed_ok_element;
	const T3GUI_ELEMENT * speed2_ok_element;
	const T3GUI_ELEMENT * timer2_ok_element;
	const T3GUI_ELEMENT * timer_ok_element;
	const T3GUI_ELEMENT * type_ok_element;
	const T3GUI_ELEMENT * par_ok_element;
	T3GUI_ELEMENT * palette_element;
	const T3GUI_ELEMENT * palette_ok_element;
	const T3GUI_ELEMENT * unsaved_save_element;
	const T3GUI_ELEMENT * unsaved_discard_element;
	int unsaved_type;
	bool unsaved_save;
	T3GUI_ELEMENT * voice_list_element;
	ALLEGRO_BITMAP * peg_bitmap;
	ALLEGRO_TRANSFORM transform;
	float display_offset_x;
	float display_offset_y;
	float display_scale_x;
	float display_scale_y;
	char copyright_message[256];

	/* project data */
	VGOLF_COURSE * course;
	int selected_asset;
	HOLE live_hole;
    int selected_hole;
    int mode;
	int selected_layer;
	int changes;
	int selected_poly;
	int selected_vert;
	int selected_point;
	int selected_image;
	int selected_vert_type;
	int selected_object;
	int vert_mode;
	int connect_count;
	char loaded_filename[1024]; // currently loaded course
	char music_filename[1024]; // music file associated with currently loaded course
	char last_filename[1024]; // most recently loaded/saved course filename
	char last_music_filename[1024]; // most recently loaded music filename
	char last_image_filename[1024]; // last/saved loaded image
	char last_hole_filename[1024]; // last/saved loaded hole
	char last_asset_filename[1024]; // last/saved loaded asset
	T3F_ANIMATION ** current_image;
	int mouse_x, mouse_y, mouse_b;
	int old_mouse_x, old_mouse_y, old_mouse_b;
	float mouse_snap_x, mouse_snap_y;
	int click_tick;
	int new_poly;
	int new_point;
	int dragging;
	int hover_poly;
	int peg_x, peg_y;
	int hover_vert;
	int hover_radius;
	int hover_object;
	int zoom;
	int ox, oy;
	int selected_radius;
	int hover_point;
	ALLEGRO_FONT * font;
	ALLEGRO_SYSTEM_MOUSE_CURSOR current_cursor;
	int course_mode;
	bool music_enabled;

} APP_INSTANCE;

#endif
