#ifndef APP_MAIN_H
#define APP_MAIN_H

#include <allegro5/allegro_native_dialog.h>

#include "core/commentary.h"
#include "t3gui/t3gui.h"

#include "instance.h"

#define CRSED_STATE_POLYGONS 0
#define CRSED_STATE_OBJECTS  1
#define CRSED_STATE_IMAGES   2
#define CRSED_STATE_BUILD    3

#define KEY_EITHER_CTRL (t3f_key[ALLEGRO_KEY_LCTRL])
#define KEY_EITHER_SHIFT (t3f_key[ALLEGRO_KEY_LSHIFT])

#define MAX_IMAGE_TYPES  29
#define MAX_OBJECT_TYPES 39

#define PEG_RADIUS        3

typedef int (*menu_proc_ptr_t)(int id, void * data);

void app_dialog_process_event(ALLEGRO_EVENT * event, T3GUI_ELEMENT * ep, void * data);
void crsed_fix_window_title(void * data);
void crsed_mark_change(void * data);
void crsed_set_cursor(void * data, ALLEGRO_SYSTEM_MOUSE_CURSOR cursor);
void app_save_config(APP_INSTANCE * app);

void crsed_event_proc(ALLEGRO_EVENT * event, void * data);
void crsed_logic(void * data);
void crsed_render(void * data);

#endif
