#include <stdio.h>
#include "t3f/t3f.h"
#include "t3f/menu.h"
#include "main.h"
#include "instance.h"
#include "ui.h"
#include "ui_dialog_proc.h"
#include "core/course.h"
#include "core/legacy_course.h"
#include "core/poly.h"
#include "ui_menu_proc.h"
#include "ui_vert.h"

void crsed_dialog_event_proc(ALLEGRO_EVENT * event, void * data)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;
	T3GUI_ELEMENT * ep = (T3GUI_ELEMENT *)event->user.data2;

	if(ep == app->unsaved_save_element)
	{
		app->unsaved_save = true;
		crsed_post_unsaved_dialog(0, data);
	}
	else if(ep == app->unsaved_discard_element)
	{
		app->unsaved_save = false;
		crsed_post_unsaved_dialog(0, data);
	}
	else if(ep == app->palette_ok_element)
	{
		switch(app->course->hole[app->selected_hole].vert[app->selected_vert].flag)
		{
			case VERT_FLAG_HOLE:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[1] = app->palette_dialog->element[1].d1;
				break;
			}
			case VERT_FLAG_POLY_MORPH:
			case VERT_FLAG_POLY_MOVE_HORIZ:
			case VERT_FLAG_POLY_MOVE_VERT:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[3] = app->palette_dialog->element[1].d1;
				break;
			}
			case VERT_FLAG_LASER_SEND:
			{
				app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[5]].ref_no[1] = app->palette_dialog->element[1].d1;
				break;
			}
			case VERT_FLAG_BLINKER:
			case VERT_FLAG_POLY_DOOR_HORIZ:
			case VERT_FLAG_POLY_DOOR_VERT:
			case VERT_FLAG_CLOUD_HORIZ:
			case VERT_FLAG_CLOUD_VERT:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[5] = app->palette_dialog->element[1].d1;
				break;
			}
		}
		crsed_vert_update_live_hole(data);
		crsed_mark_change(data);
	}
	else if(ep == app->par_ok_element)
	{
		int i;

		if(app->course->hole[app->selected_hole].par_score != atoi(crsed_edit_text[0]))
		{
			app->course->hole[app->selected_hole].par_score = atoi(crsed_edit_text[0]);
			app->course->course_par = 0;
			for(i = 0; i < app->course->num_holes; i++)
			{
				app->course->course_par += app->course->hole[i].par_score;
			}
			crsed_mark_change(data);
		}
	}
	else if(ep == app->timer_ok_element)
	{
		switch(app->course->hole[app->selected_hole].vert[app->selected_vert].flag)
		{
			case VERT_FLAG_PIPE_ENTER:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[3] = atoi(crsed_edit_text[0]);
				break;
			}
			case VERT_FLAG_BLINKER:
			case VERT_FLAG_LASER_SEND:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[2] = atoi(crsed_edit_text[0]);
				break;
			}
			case VERT_FLAG_POLY_DOOR_HORIZ:
			case VERT_FLAG_POLY_DOOR_VERT:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[2] = atoi(crsed_edit_text[0]);
				break;
			}
		}
		crsed_vert_update_live_hole(data);
		crsed_mark_change(data);
	}
	else if(ep == app->timer2_ok_element)
	{
		switch(app->course->hole[app->selected_hole].vert[app->selected_vert].flag)
		{
			case VERT_FLAG_BLINKER:
			case VERT_FLAG_LASER_SEND:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[3] = atoi(crsed_edit_text[0]);
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[1] = vgolf_course_make_color(app->course, 255, 255, 255);
				break;
			}
		}
		crsed_vert_update_live_hole(data);
		crsed_mark_change(data);
	}
	else if(ep == app->speed_ok_element)
	{
		switch(app->course->hole[app->selected_hole].vert[app->selected_vert].flag)
		{
			case VERT_FLAG_POLY_MORPH:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[2] = atoi(crsed_edit_text[0]);
				break;
			}
			case VERT_FLAG_POLY_MOVE_HORIZ:
			case VERT_FLAG_POLY_MOVE_VERT:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[5] = atoi(crsed_edit_text[0]);
				break;
			}
			case VERT_FLAG_POLY_DOOR_HORIZ:
			case VERT_FLAG_POLY_DOOR_VERT:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[3] = atoi(crsed_edit_text[0]);
				break;
			}
			case VERT_FLAG_CONVEYOR:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[2] = atoi(crsed_edit_text[0]);
				break;
			}
			case VERT_FLAG_ANIMAL_0:
			case VERT_FLAG_ANIMAL_1:
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[1] = atoi(crsed_edit_text[0]);
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[2] = atoi(crsed_edit_text[1]);
				break;
			}
		}
		crsed_vert_update_live_hole(data);
		crsed_mark_change(data);
	}
	else if(ep == app->size_ok_element)
	{
		app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[2] = 0;
		app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[4] = atoi(crsed_edit_text[0]);
		crsed_vert_update_live_hole(data);
		crsed_mark_change(data);
	}
	else if(ep == app->direction_ok_element)
	{
		int i;

		for(i = 1; i < 5; i++)
		{
			if(app->direction_dialog->element[i].flags & D_SELECTED)
			{
				app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0] = i - 1;
				break;
			}
		}
		crsed_vert_update_live_hole(data);
		crsed_mark_change(data);
	}
	else if(ep == app->type_ok_element)
	{
		app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[4] = atoi(crsed_edit_text[0]);
		crsed_vert_update_live_hole(data);
		crsed_mark_change(data);
	}
	else if(ep == app->target_layer_ok_element)
	{
		app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[1] = atoi(crsed_edit_text[0]);
		crsed_vert_update_live_hole(data);
		crsed_mark_change(data);
	}
	else if(ep == app->layer_ok_element)
	{
		app->course->hole[app->selected_hole].vert[app->selected_vert].layer = atoi(crsed_edit_text[0]);
		crsed_vert_update_live_hole(data);
		crsed_mark_change(data);
	}
	else if(ep == app->tags_ok_element)
	{
		if(strcmp(app->course->name, crsed_edit_text[0]) || strcmp(app->course->author, crsed_edit_text[1]) || strcmp(app->course->comment, crsed_edit_text[2]))
		{
			strcpy(app->course->name, crsed_edit_text[0]);
			strcpy(app->course->author, crsed_edit_text[1]);
			strcpy(app->course->comment, crsed_edit_text[2]);
			crsed_mark_change(data);
		}
	}

	/* if we are closing the last dialog, re-enable menus */
	if(t3gui_get_active_dialogs() <= 1)
	{
		t3f_enable_menus(true);
	}
}
