#include "t3f/t3f.h"
#include "t3f/menu.h"
#include "ui.h"
#include "ui_dialog_proc.h"
#include "instance.h"
#include "main.h"
#include "tables.h"
#include "ui_vert.h"
#include "editor_core/ui_element_palette.h"
#include "editor_core/ui_element_image.h"
#include "ui_menu_proc.h"

int crsed_add_menu_item(ALLEGRO_MENU * menu, const char * name, int (*proc)(int id, void * data), ALLEGRO_MENU * sub, int flags, int (*update_proc)(ALLEGRO_MENU * menu, int item, void * data))
{
    return t3f_add_menu_item(menu, name, flags, sub, proc, update_proc);
}

bool crsed_setup_menus(APP_INSTANCE * app)
{
    int i;

    app->file_menu = al_create_menu();
    if(!app->file_menu)
    {
        return false;
    }
    crsed_add_menu_item(app->file_menu, "New", crsed_menu_file_new, NULL, 0, NULL);
    crsed_add_menu_item(app->file_menu, "Open", crsed_menu_file_load, NULL, 0, NULL);
    crsed_add_menu_item(app->file_menu, "Save", crsed_menu_file_save, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_file_save_update_proc);
    crsed_add_menu_item(app->file_menu, "Save As", crsed_menu_file_save_as, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_file_save_update_proc);
    crsed_add_menu_item(app->file_menu, "Package", crsed_menu_file_package, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_file_save_update_proc);
    crsed_add_menu_item(app->file_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->file_menu, "Load Palette", crsed_menu_file_load_palette, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_file_save_update_proc);
    crsed_add_menu_item(app->file_menu, "Save Palette", crsed_menu_file_save_palette, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_file_save_update_proc);
    crsed_add_menu_item(app->file_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->file_menu, "Course Tags", crsed_menu_file_course_tags, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_file_save_update_proc);
    crsed_add_menu_item(app->file_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->file_menu, "Exit", crsed_menu_file_exit, NULL, 0, NULL);

    app->hole_select_menu = al_create_menu();
    if(!app->hole_select_menu)
    {
        return false;
    }
    app->hole_menu_id[0] = crsed_add_menu_item(app->hole_select_menu, "1", crsed_menu_hole_select_0, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[1] = crsed_add_menu_item(app->hole_select_menu, "2", crsed_menu_hole_select_1, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[2] = crsed_add_menu_item(app->hole_select_menu, "3", crsed_menu_hole_select_2, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[3] = crsed_add_menu_item(app->hole_select_menu, "4", crsed_menu_hole_select_3, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[4] = crsed_add_menu_item(app->hole_select_menu, "5", crsed_menu_hole_select_4, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[5] = crsed_add_menu_item(app->hole_select_menu, "6", crsed_menu_hole_select_5, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[6] = crsed_add_menu_item(app->hole_select_menu, "7", crsed_menu_hole_select_6, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[7] = crsed_add_menu_item(app->hole_select_menu, "8", crsed_menu_hole_select_7, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[8] = crsed_add_menu_item(app->hole_select_menu, "9", crsed_menu_hole_select_8, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[9] = crsed_add_menu_item(app->hole_select_menu, "10", crsed_menu_hole_select_9, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[10] = crsed_add_menu_item(app->hole_select_menu, "11", crsed_menu_hole_select_10, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[11] = crsed_add_menu_item(app->hole_select_menu, "12", crsed_menu_hole_select_11, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[12] = crsed_add_menu_item(app->hole_select_menu, "13", crsed_menu_hole_select_12, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[13] = crsed_add_menu_item(app->hole_select_menu, "14", crsed_menu_hole_select_13, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[14] = crsed_add_menu_item(app->hole_select_menu, "15", crsed_menu_hole_select_14, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[15] = crsed_add_menu_item(app->hole_select_menu, "16", crsed_menu_hole_select_15, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[16] = crsed_add_menu_item(app->hole_select_menu, "17", crsed_menu_hole_select_16, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);
    app->hole_menu_id[17] = crsed_add_menu_item(app->hole_select_menu, "18", crsed_menu_hole_select_17, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_select_update_proc);

    app->hole_layer_menu = al_create_menu();
    if(!app->hole_layer_menu)
    {
        return false;
    }
    app->layer_menu_id[0] = crsed_add_menu_item(app->hole_layer_menu, "Layer 0", crsed_menu_poly_layer_0, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_layer_update_proc);
    app->layer_menu_id[1] = crsed_add_menu_item(app->hole_layer_menu, "Layer 1", crsed_menu_poly_layer_1, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_layer_update_proc);
    app->layer_menu_id[2] = crsed_add_menu_item(app->hole_layer_menu, "Layer 2", crsed_menu_poly_layer_2, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_hole_layer_update_proc);

    app->hole_menu = al_create_menu();
    if(!app->hole_menu)
    {
        return false;
    }
    crsed_add_menu_item(app->hole_menu, "Select", NULL, app->hole_select_menu, 0, NULL);
    crsed_add_menu_item(app->hole_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->hole_menu, "Add", crsed_menu_hole_add, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_hole_add_update_proc);
    crsed_add_menu_item(app->hole_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->hole_menu, "Layer", NULL, app->hole_layer_menu, 0, NULL);
    crsed_add_menu_item(app->hole_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->hole_menu, "Load Image", crsed_menu_hole_load_image, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_hole_edit_update_proc);
    crsed_add_menu_item(app->hole_menu, "Save Image", crsed_menu_hole_save_image, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_hole_image_loaded_update_proc);
    crsed_add_menu_item(app->hole_menu, "Remove Image", crsed_menu_hole_remove_image, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_hole_image_loaded_update_proc);
    crsed_add_menu_item(app->hole_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->hole_menu, "Set Par", crsed_menu_hole_set_par, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_hole_edit_update_proc);
    crsed_add_menu_item(app->hole_menu, NULL, NULL, NULL, 0, NULL);
//    crsed_add_menu_item(app->hole_menu, "Import", crsed_menu_hole_import, NULL, 0, NULL);
//    crsed_add_menu_item(app->hole_menu, "Export", crsed_menu_hole_export, NULL, 0, NULL);
//    crsed_add_menu_item(app->hole_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->hole_menu, "Delete", crsed_menu_hole_delete, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_hole_edit_update_proc);

    app->mode_menu = al_create_menu();
    if(!app->mode_menu)
    {
        return false;
    }
    app->mode_menu_id[0] = crsed_add_menu_item(app->mode_menu, "Polygons", crsed_menu_mode_polygons, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_mode_update_proc);
    app->mode_menu_id[1] = crsed_add_menu_item(app->mode_menu, "Objects", crsed_menu_mode_objects, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_mode_update_proc);
    app->mode_menu_id[2] = crsed_add_menu_item(app->mode_menu, "Images", crsed_menu_mode_images, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_mode_update_proc);

    app->object_type_menu = al_create_menu();
    if(!app->object_type_menu)
    {
        return false;
    }
    for(i = 0; i < MAX_OBJECT_TYPES; i++)
    {
        app->object_menu_id[i] = crsed_add_menu_item(app->object_type_menu, crsed_object_type_name[i], crsed_object_type_proc[i], NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_object_type_update_proc);
    }

    app->poly_menu = al_create_menu();
    if(!app->poly_menu)
    {
        return false;
    }
    crsed_add_menu_item(app->poly_menu, "Invert", crsed_menu_poly_invert, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_poly_edit_update_proc);
    crsed_add_menu_item(app->poly_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->poly_menu, "Delete Vertex", crsed_menu_poly_delete_vertex, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_poly_edit_update_proc);
    crsed_add_menu_item(app->poly_menu, "Delete Polygon", crsed_menu_poly_delete, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_poly_edit_update_proc);

    app->object_properties_menu = al_create_menu();
    if(!app->object_properties_menu)
    {
        return false;
    }
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_COLOR] = crsed_add_menu_item(app->object_properties_menu, "Color", crsed_menu_object_properties_color, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_CONNECT] = crsed_add_menu_item(app->object_properties_menu, "Connect", crsed_menu_object_properties_connect, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_SET_TYPE] = crsed_add_menu_item(app->object_properties_menu, "Set Type", crsed_menu_object_properties_set_type, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_ANGLE] = crsed_add_menu_item(app->object_properties_menu, "Set Angle", crsed_menu_object_properties_set_angle, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_TIMER] = crsed_add_menu_item(app->object_properties_menu, "Set Timer", crsed_menu_object_properties_set_timer, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_TIMER2] = crsed_add_menu_item(app->object_properties_menu, "Set Timer 2", crsed_menu_object_properties_set_timer2, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_SPEED] = crsed_add_menu_item(app->object_properties_menu, "Set Speed", crsed_menu_object_properties_set_speed, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_SIZE] = crsed_add_menu_item(app->object_properties_menu, "Set Size", crsed_menu_object_properties_set_size, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_DIRECTION] = crsed_add_menu_item(app->object_properties_menu, "Set Direction", crsed_menu_object_properties_set_direction, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_SET_TARGET_LAYER] = crsed_add_menu_item(app->object_properties_menu, "Set Target Layer", crsed_menu_object_properties_set_target_layer, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);
    app->object_properties_menu_id[CRSED_GUI_OBJECT_PROPERTIES_SET_LAYER] = crsed_add_menu_item(app->object_properties_menu, "Set Layer", crsed_menu_object_properties_set_layer, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_properties_update_proc);

    app->object_menu = al_create_menu();
    if(!app->object_menu)
    {
        return false;
    }
    crsed_add_menu_item(app->object_menu, "Type", NULL, app->object_type_menu, 0, NULL);
    crsed_add_menu_item(app->object_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->object_menu, "Properties", NULL, app->object_properties_menu, 0, NULL);
    crsed_add_menu_item(app->object_menu, NULL, NULL, NULL, 0, NULL);
	crsed_add_menu_item(app->object_menu, "Move Up", crsed_menu_object_move_up, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_move_up_update_proc);
	crsed_add_menu_item(app->object_menu, "Move Down", crsed_menu_object_move_down, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_move_down_update_proc);
	crsed_add_menu_item(app->object_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->object_menu, "Delete", crsed_menu_object_delete, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_object_edit_update_proc);

    app->image_type_end_menu = al_create_menu();
    if(!app->image_type_end_menu)
    {
        return false;
    }
    app->image_menu_id[2] = crsed_add_menu_item(app->image_type_end_menu, "BG", crsed_menu_image_type_end_bg, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[3] = crsed_add_menu_item(app->image_type_end_menu, "Podium", crsed_menu_image_type_end_podium, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[4] = crsed_add_menu_item(app->image_type_end_menu, "Cloud 1", crsed_menu_image_type_end_cloud_1, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[5] = crsed_add_menu_item(app->image_type_end_menu, "Cloud 2", crsed_menu_image_type_end_cloud_2, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[6] = crsed_add_menu_item(app->image_type_end_menu, "1st Trophy", crsed_menu_image_type_1st_trophy, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[7] = crsed_add_menu_item(app->image_type_end_menu, "2nd Trophy", crsed_menu_image_type_2nd_trophy, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[8] = crsed_add_menu_item(app->image_type_end_menu, "3rd Trophy", crsed_menu_image_type_3rd_trophy, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);

    app->image_type_object_menu = al_create_menu();
    if(!app->image_type_object_menu)
    {
        return false;
    }
    app->image_menu_id[9] = crsed_add_menu_item(app->image_type_object_menu, "Hole", crsed_menu_image_type_object_hole, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[10] = crsed_add_menu_item(app->image_type_object_menu, "Hole Sunk", crsed_menu_image_type_object_hole_sunk, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[11] = crsed_add_menu_item(app->image_type_object_menu, "Tree 1", crsed_menu_image_type_object_tree_1, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[12] = crsed_add_menu_item(app->image_type_object_menu, "Tree 2", crsed_menu_image_type_object_tree_2, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[13] = crsed_add_menu_item(app->image_type_object_menu, "Laser Off", crsed_menu_image_type_object_laser_1, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[14] = crsed_add_menu_item(app->image_type_object_menu, "Laser On", crsed_menu_image_type_object_laser_2, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[15] = crsed_add_menu_item(app->image_type_object_menu, "Teleport 1", crsed_menu_image_type_object_teleport_1, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[16] = crsed_add_menu_item(app->image_type_object_menu, "Teleport 2", crsed_menu_image_type_object_teleport_2, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[17] = crsed_add_menu_item(app->image_type_object_menu, "Conveyor 1", crsed_menu_image_type_object_conveyor_1, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[18] = crsed_add_menu_item(app->image_type_object_menu, "Conveyor 2", crsed_menu_image_type_object_conveyor_2, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[19] = crsed_add_menu_item(app->image_type_object_menu, "Conveyor 3", crsed_menu_image_type_object_conveyor_3, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[20] = crsed_add_menu_item(app->image_type_object_menu, "Conveyor 4", crsed_menu_image_type_object_conveyor_4, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[21] = crsed_add_menu_item(app->image_type_object_menu, "Animal 1 Right 1", crsed_menu_image_type_object_animal_1_1, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[22] = crsed_add_menu_item(app->image_type_object_menu, "Animal 1 Right 2", crsed_menu_image_type_object_animal_1_2, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[23] = crsed_add_menu_item(app->image_type_object_menu, "Animal 1 Left 1", crsed_menu_image_type_object_animal_1_3, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[24] = crsed_add_menu_item(app->image_type_object_menu, "Animal 1 Left 2", crsed_menu_image_type_object_animal_1_4, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[25] = crsed_add_menu_item(app->image_type_object_menu, "Animal 2 Right 1", crsed_menu_image_type_object_animal_2_1, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[26] = crsed_add_menu_item(app->image_type_object_menu, "Animal 2 Right 2", crsed_menu_image_type_object_animal_2_2, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[27] = crsed_add_menu_item(app->image_type_object_menu, "Animal 2 Left 1", crsed_menu_image_type_object_animal_2_3, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[28] = crsed_add_menu_item(app->image_type_object_menu, "Animal 2 Left 2", crsed_menu_image_type_object_animal_2_4, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);

    app->image_type_menu = al_create_menu();
    if(!app->image_type_menu)
    {
        return false;
    }
    app->image_menu_id[0] = crsed_add_menu_item(app->image_type_menu, "Title", crsed_menu_image_type_title, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    app->image_menu_id[1] = crsed_add_menu_item(app->image_type_menu, "Scoreboard", crsed_menu_image_type_scoreboard, NULL, ALLEGRO_MENU_ITEM_DISABLED | ALLEGRO_MENU_ITEM_CHECKBOX, menu_image_update_proc);
    crsed_add_menu_item(app->image_type_menu, "Ending", NULL, app->image_type_end_menu, 0, NULL);
    crsed_add_menu_item(app->image_type_menu, "Object", NULL, app->image_type_object_menu, 0, NULL);

    app->image_menu = al_create_menu();
    if(!app->image_menu)
    {
        return false;
    }
    crsed_add_menu_item(app->image_menu, "Type", NULL, app->image_type_menu, 0, NULL);
    crsed_add_menu_item(app->image_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->image_menu, "Load", crsed_menu_image_load, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_image_update_proc);
    crsed_add_menu_item(app->image_menu, "Save", crsed_menu_image_save, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_image_update_proc);
	crsed_add_menu_item(app->image_menu, "Clear", crsed_menu_image_clear, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_image_update_proc);

    app->music_menu = al_create_menu();
    if(!app->music_menu)
    {
        return false;
    }
    crsed_add_menu_item(app->music_menu, "Choose", crsed_menu_music_choose, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_file_save_update_proc);
    crsed_add_menu_item(app->music_menu, "Remove", crsed_menu_music_remove, NULL, ALLEGRO_MENU_ITEM_DISABLED, menu_music_remove_update_proc);
    crsed_add_menu_item(app->music_menu, "Listen", crsed_menu_music_listen, NULL, ALLEGRO_MENU_ITEM_CHECKED, menu_music_listen_update_proc);
    if(!app->music_enabled)
    {
        crsed_menu_music_listen(0, app);
        crsed_menu_music_listen(0, app);
    }

    app->help_menu = al_create_menu();
    if(!app->help_menu)
    {
        return false;
    }
    crsed_add_menu_item(app->help_menu, "Manual", crsed_menu_help_manual, NULL, 0, NULL);
    crsed_add_menu_item(app->help_menu, NULL, NULL, NULL, 0, NULL);
    crsed_add_menu_item(app->help_menu, "About", crsed_menu_help_about, NULL, 0, NULL);

    app->main_menu = al_create_menu();
    if(!app->main_menu)
    {
        return false;
    }
    crsed_add_menu_item(app->main_menu, "File", NULL, app->file_menu, 0, NULL);
    crsed_add_menu_item(app->main_menu, "Mode", NULL, app->mode_menu, 0, NULL);
    crsed_add_menu_item(app->main_menu, "Hole", NULL, app->hole_menu, 0, NULL);
    crsed_add_menu_item(app->main_menu, "Polygon", NULL, app->poly_menu, 0, NULL);
    crsed_add_menu_item(app->main_menu, "Object", NULL, app->object_menu, 0, NULL);
    crsed_add_menu_item(app->main_menu, "Image", NULL, app->image_menu, 0, NULL);
    crsed_add_menu_item(app->main_menu, "Music", NULL, app->music_menu, 0, NULL);
    crsed_add_menu_item(app->main_menu, "Help", NULL, app->help_menu, 0, NULL);

    return true;
}

bool crsed_setup_dialogs(APP_INSTANCE * app)
{
    int text_width;
    int font_height;
    int bezel = 8;

    app->palette_dialog = t3gui_create_dialog();
    if(!app->palette_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->palette_dialog, app->button_theme, t3gui_window_frame_proc, 0, 0, 272, 256 + 8 + 32 + 24, 0, 0, 0, 0, "Properties", NULL, NULL);
    app->palette_element = t3gui_dialog_add_element(app->palette_dialog, NULL, d_crsed_palette_proc, 8, 24, 256, 256, 0, 0, 0, 0, app->palette_bitmap, NULL, NULL);
    app->palette_ok_element = t3gui_dialog_add_element(app->palette_dialog, app->button_theme, t3gui_button_proc, 8, 256 + 8 + 24, 272 - 8, 32, '\r', D_EXIT, 0, 0, "Okay", NULL, NULL);

    app->unsaved_dialog = t3gui_create_dialog();
    if(!app->unsaved_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->unsaved_dialog, app->button_theme, t3gui_box_proc, 0, 0, 192, 160, 0, 0, 0, 0, "Save Changes", NULL, NULL);
    t3gui_dialog_add_element(app->unsaved_dialog, app->button_theme, t3gui_textbox_proc, 8, 8 + 22 * 0, 176, 40, 0, 0, 0, 0, "You have unsaved changes!", NULL, NULL);
    app->unsaved_save_element = t3gui_dialog_add_element(app->unsaved_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4, 176, 32, 0, D_EXIT, 0, 0, "Save", NULL, NULL);
    app->unsaved_discard_element = t3gui_dialog_add_element(app->unsaved_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4 + 32 * 1, 176, 32, 0, D_EXIT, 0, 0, "Discard", NULL, NULL);
    t3gui_dialog_add_element(app->unsaved_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4 + 32 * 2, 176, 32, 0, D_EXIT, 0, 0, "Cancel", NULL, NULL);

    text_width = al_get_text_width(app->button_theme->state[0].font[0], T3F_APP_TITLE " v" T3F_APP_VERSION);
    font_height = al_get_font_line_height(app->button_theme->state[0].font[0]);
	app->about_dialog = t3gui_create_dialog();
	if(!app->about_dialog)
	{
		return false;
	}
	t3gui_dialog_add_element(app->about_dialog, app->button_theme, t3gui_box_proc, 0, 0, bezel + text_width + bezel, bezel + font_height * 2 + bezel + 32 + bezel, 0, 0, 0, 0, NULL, NULL, NULL);
	t3gui_dialog_add_element(app->about_dialog, app->button_theme, t3gui_text_proc, bezel, bezel, text_width, font_height, 0, 0, ALLEGRO_ALIGN_CENTRE, 0, T3F_APP_TITLE " v" T3F_APP_VERSION, NULL, NULL);
	t3gui_dialog_add_element(app->about_dialog, app->button_theme, t3gui_text_proc, bezel, bezel + font_height, text_width, font_height, 0, 0, ALLEGRO_ALIGN_CENTRE, 0, app->copyright_message, NULL, NULL);
	t3gui_dialog_add_element(app->about_dialog, app->button_theme, t3gui_push_button_proc, bezel + text_width / 2 - 32, bezel + font_height * 2 + bezel, 64, 32, 0, D_EXIT, 0, 0, "Okay", NULL, NULL);

    app->type_dialog = t3gui_create_dialog();
    if(!app->type_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->type_dialog, app->button_theme, t3gui_box_proc, 0, 0, 128, 98, 0, 0, 0, 0, "Properties", NULL, NULL);
    t3gui_dialog_add_element(app->type_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 0, 112, 20, 0, 0, 0, 0, "Type:", NULL, NULL);
    t3gui_dialog_add_element(app->type_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 1, 112, 20, 0, D_SETFOCUS, 3, 0, crsed_edit_text[0], NULL, NULL);
    app->type_ok_element = t3gui_dialog_add_element(app->type_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4, 112, 32, '\r', D_EXIT, 0, 0, "Okay", NULL, NULL);

    app->timer_dialog = t3gui_create_dialog();
    if(!app->timer_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->timer_dialog, app->button_theme, t3gui_box_proc, 0, 0, 128, 98, 0, 0, 0, 0, "Properties", NULL, NULL);
    t3gui_dialog_add_element(app->timer_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 0, 112, 20, 0, 0, 0, 0, "Timer:", NULL, NULL);
    t3gui_dialog_add_element(app->timer_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 1, 112, 20, 0, D_SETFOCUS, 3, 0, crsed_edit_text[0], NULL, NULL);
    app->timer_ok_element = t3gui_dialog_add_element(app->timer_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4, 112, 32, '\r', D_EXIT, 0, 0, "Okay", NULL, NULL);

    app->timer2_dialog = t3gui_create_dialog();
    if(!app->timer2_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->timer2_dialog, app->button_theme, t3gui_box_proc, 0, 0, 128, 98, 0, 0, 0, 0, "Properties", NULL, NULL);
    t3gui_dialog_add_element(app->timer2_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 0, 112, 20, 0, 0, 0, 0, "Timer 2:", NULL, NULL);
    t3gui_dialog_add_element(app->timer2_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 1, 112, 20, 0, D_SETFOCUS, 3, 0, crsed_edit_text[0], NULL, NULL);
    app->timer2_ok_element = t3gui_dialog_add_element(app->timer2_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4, 112, 32, '\r', D_EXIT, 0, 0, "Okay", NULL, NULL);

    app->speed_dialog = t3gui_create_dialog();
    if(!app->speed_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->speed_dialog, app->button_theme, t3gui_box_proc, 0, 0, 128, 98, 0, 0, 0, 0, "Properties", NULL, NULL);
    t3gui_dialog_add_element(app->speed_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 0, 112, 20, 0, 0, 0, 0, "Speed:", NULL, NULL);
    t3gui_dialog_add_element(app->speed_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 1, 112, 20, 0, D_SETFOCUS, 3, 0, crsed_edit_text[0], NULL, NULL);
    app->speed_ok_element = t3gui_dialog_add_element(app->speed_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2, 112, 32, '\r', D_EXIT, 0, 0,  "Okay",  NULL, NULL);

    app->speed2_dialog = t3gui_create_dialog();
    if(!app->speed2_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->speed2_dialog, app->button_theme, t3gui_box_proc, 0, 0, 136, 112, 0, 0, 0, 0,  "Properties", NULL, NULL);
    t3gui_dialog_add_element(app->speed2_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 0, 112, 20, 0, 0, 0, 0, "X Speed:", NULL, NULL);
    t3gui_dialog_add_element(app->speed2_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 1, 112, 20, 0, D_SETFOCUS, 3, 0, crsed_edit_text[0], NULL, NULL);
    t3gui_dialog_add_element(app->speed2_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 2, 112, 20, 0, 0, 0,  0, "Y Speed:", NULL, NULL);
    t3gui_dialog_add_element(app->speed2_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 3, 112, 20, 0, 0, 3, 0, crsed_edit_text[1], NULL, NULL);
    app->speed2_ok_element = t3gui_dialog_add_element(app->speed2_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 4 + 4, 112,  32, '\r', D_EXIT, 0, 0,  "Okay",  NULL, NULL);

    app->tags_dialog = t3gui_create_dialog();
	if(!app->tags_dialog)
	{
		return false;
	}
	if(!t3gui_dialog_add_element(app->tags_dialog, app->button_theme, t3gui_box_proc, 160 - 16, 120 - 16, 320 + 32, 360 + 27, 0, 0, 0, 0, NULL, NULL, NULL))
	{
		return false;
	}
	if(!t3gui_dialog_add_element(app->tags_dialog, app->text_box_theme, t3gui_text_proc, 160, 120, 320, 20, 0, 0, ALLEGRO_ALIGN_LEFT, 0, "Title", NULL, NULL))
	{
		return false;
	}
	if(!t3gui_dialog_add_element(app->tags_dialog, app->text_box_theme, t3gui_edit_proc, 160, 120 + 22 * 1, 320, 20, 0, D_SETFOCUS, 256, 0, crsed_edit_text[0], NULL, NULL))
	{
		return false;
	}
	if(!t3gui_dialog_add_element(app->tags_dialog, app->text_box_theme, t3gui_text_proc, 160, 120 + 22 * 3, 320, 16, 0, 0, ALLEGRO_ALIGN_LEFT, 0, "Author", NULL, NULL))
	{
		return false;
	}
	if(!t3gui_dialog_add_element(app->tags_dialog, app->text_box_theme, t3gui_edit_proc, 160, 120 + 22 * 4, 320, 20, 0, 0, 256, 0, crsed_edit_text[1], NULL, NULL))
	{
		return false;
	}
	if(!t3gui_dialog_add_element(app->tags_dialog, app->text_box_theme, t3gui_text_proc, 160, 120 + 22 * 6, 320, 16, 0, 0, ALLEGRO_ALIGN_LEFT, 0, "Comment", NULL, NULL))
	{
		return false;
	}
	if(!t3gui_dialog_add_element(app->tags_dialog, app->text_box_theme, t3gui_editbox_proc, 160, 120 + 22 * 7, 320, 147, 0, 0, 1024, 0, crsed_edit_text[2], NULL, NULL))
	{
		return false;
	}
	app->tags_ok_element = t3gui_dialog_add_element(app->tags_dialog, app->button_theme, t3gui_button_proc, 160, 120 - 16 + 360 - 25, 160, 32, 0, D_EXIT, ALLEGRO_ALIGN_LEFT, 0, "Okay", NULL, NULL);
	if(!t3gui_dialog_add_element(app->tags_dialog, app->button_theme, t3gui_button_proc, 320, 120 - 16 + 360 - 25, 160, 32, 0, D_EXIT, ALLEGRO_ALIGN_LEFT, 0, "Cancel", NULL, NULL))
    {
        return false;
    }

    app->direction_dialog = t3gui_create_dialog();
    if(!app->direction_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->direction_dialog, app->button_theme, t3gui_box_proc, 0, 0, 136, 160, 0, 0, 0, 0,  "Properties", NULL, NULL);
    t3gui_dialog_add_element(app->direction_dialog, app->button_theme, t3gui_radio_proc, 24, 22, 80, 20, 0, 0, 0, 0, "Up", NULL, NULL);
    t3gui_dialog_add_element(app->direction_dialog, app->button_theme, t3gui_radio_proc, 24, 44, 80, 20, 0, 0, 0, 0, "Down", NULL, NULL);
    t3gui_dialog_add_element(app->direction_dialog, app->button_theme, t3gui_radio_proc, 24, 66, 80, 20, 0, 0, 0, 0, "Left", NULL, NULL);
    t3gui_dialog_add_element(app->direction_dialog, app->button_theme, t3gui_radio_proc, 24, 88, 80, 20, 0, 0, 0, 0, "Right", NULL, NULL);
    app->direction_ok_element = t3gui_dialog_add_element(app->direction_dialog, app->button_theme, t3gui_button_proc, 8, 120, 120, 32, '\r', D_EXIT, 0, 0, "Okay", NULL, NULL);

    app->size_dialog = t3gui_create_dialog();
    if(!app->size_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->size_dialog, app->button_theme, t3gui_window_frame_proc, 0, 0, 128, 98, 0, 0, 0, 0, "Properties",  NULL, NULL);
    t3gui_dialog_add_element(app->size_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 0, 112, 20, 0, 0, 0, 0, "Size:", NULL, NULL);
    t3gui_dialog_add_element(app->size_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 1, 112, 20, 0, D_SETFOCUS, 3, 0, crsed_edit_text[0], NULL, NULL);
    app->size_ok_element = t3gui_dialog_add_element(app->size_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4, 112, 32, '\r', D_EXIT, 0, 0, "Okay", NULL, NULL);

    app->layer_dialog = t3gui_create_dialog();
    if(!app->layer_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->layer_dialog, app->button_theme, t3gui_box_proc, 0, 0, 128, 98, 0, 0, 0, 0,  "Properties",  NULL, NULL);
    t3gui_dialog_add_element(app->layer_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 0, 112, 20, 0, 0, 0, 0, "Layer:", NULL, NULL);
    t3gui_dialog_add_element(app->layer_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 1, 112, 20, 0, D_SETFOCUS, 3, 0, crsed_edit_text[0], NULL, NULL);
    app->layer_ok_element = t3gui_dialog_add_element(app->layer_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4, 112, 32, '\r', D_EXIT, 0, 0,  "Okay",  NULL, NULL);

    app->target_layer_dialog = t3gui_create_dialog();
    if(!app->target_layer_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->target_layer_dialog, app->button_theme, t3gui_box_proc, 0, 0, 128, 98, 0, 0, 0, 0,  "Properties",  NULL, NULL);
    t3gui_dialog_add_element(app->target_layer_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 0, 112, 20, 0, 0, 0, 0, "Layer:", NULL, NULL);
    t3gui_dialog_add_element(app->target_layer_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 1, 112, 20, 0, D_SETFOCUS, 3, 0, crsed_edit_text[0], NULL, NULL);
    app->target_layer_ok_element = t3gui_dialog_add_element(app->target_layer_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4, 112, 32, '\r', D_EXIT, 0, 0,  "Okay",  NULL, NULL);

    app->par_dialog = t3gui_create_dialog();
    if(!app->par_dialog)
    {
        return false;
    }
    t3gui_dialog_add_element(app->par_dialog, app->button_theme, t3gui_box_proc, 0, 0, 128, 98, 0, 0, 0, 0,  "Hole", NULL, NULL);
    t3gui_dialog_add_element(app->par_dialog, app->button_theme, t3gui_text_proc, 8, 8 + 22 * 0, 112, 20, 0, 0, 0, 0, "Par", NULL, NULL);
    t3gui_dialog_add_element(app->par_dialog, app->text_box_theme, t3gui_edit_proc, 8, 8 + 22 * 1, 112, 20, 0, D_SETFOCUS, 3, 0, crsed_edit_text[0], NULL, NULL);
    app->par_ok_element = t3gui_dialog_add_element(app->par_dialog, app->button_theme, t3gui_button_proc, 8, 8 + 22 * 2 + 4, 112, 32, '\r', D_EXIT, 0, 0,  "Okay", NULL, NULL);
    crsed_center_dialogs(app, al_get_display_width(t3f_display), al_get_display_height(t3f_display));

    return true;
}
