#ifndef CRSED_UI_MENU_PROC_H
#define CRSED_UI_MENU_PROC_H

#include "t3f/t3f.h"

/* menu updaters */
int menu_file_save_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_hole_select_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_hole_add_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_hole_edit_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_hole_layer_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_hole_image_loaded_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_mode_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_poly_edit_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_object_edit_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_object_move_up_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_object_move_down_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_object_type_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_object_properties_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_image_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_build_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_music_remove_update_proc(ALLEGRO_MENU * menu, int item, void * data);
int menu_music_listen_update_proc(ALLEGRO_MENU * menu, int item, void * data);

/* menu procedures */
int crsed_menu_file_new(int id, void * data);
int crsed_menu_file_load(int id, void * data);
int crsed_menu_file_save(int id, void * data);
int crsed_menu_file_save_as(int id, void * data);
int crsed_menu_file_package(int id, void * data);
int crsed_menu_file_import(int id, void * data);
int crsed_menu_file_load_palette(int id, void * data);
int crsed_menu_file_save_palette(int id, void * data);
int crsed_menu_file_course_tags(int id, void * data);
int crsed_menu_file_exit(int id, void * data);

int crsed_menu_mode_polygons(int id, void * data);
int crsed_menu_mode_objects(int id, void * data);
int crsed_menu_mode_images(int id, void * data);

int crsed_menu_hole_select_0(int id, void * data);
int crsed_menu_hole_select_1(int id, void * data);
int crsed_menu_hole_select_2(int id, void * data);
int crsed_menu_hole_select_3(int id, void * data);
int crsed_menu_hole_select_4(int id, void * data);
int crsed_menu_hole_select_5(int id, void * data);
int crsed_menu_hole_select_6(int id, void * data);
int crsed_menu_hole_select_7(int id, void * data);
int crsed_menu_hole_select_8(int id, void * data);
int crsed_menu_hole_select_9(int id, void * data);
int crsed_menu_hole_select_10(int id, void * data);
int crsed_menu_hole_select_11(int id, void * data);
int crsed_menu_hole_select_12(int id, void * data);
int crsed_menu_hole_select_13(int id, void * data);
int crsed_menu_hole_select_14(int id, void * data);
int crsed_menu_hole_select_15(int id, void * data);
int crsed_menu_hole_select_16(int id, void * data);
int crsed_menu_hole_select_17(int id, void * data);
int crsed_menu_hole_add(int id, void * data);
int crsed_menu_hole_load_image(int id, void * data);
int crsed_menu_hole_save_image(int id, void * data);
int crsed_menu_hole_remove_image(int id, void * data);
int crsed_menu_hole_set_par(int id, void * data);
int crsed_menu_hole_import(int id, void * data);
int crsed_menu_hole_export(int id, void * data);
int crsed_menu_hole_delete(int id, void * data);

int crsed_menu_poly_layer_0(int id, void * data);
int crsed_menu_poly_layer_1(int id, void * data);
int crsed_menu_poly_layer_2(int id, void * data);

int crsed_menu_poly_invert(int id, void * data);
int crsed_menu_poly_delete(int id, void * data);
int crsed_menu_poly_delete_vertex(int id, void * data);

int crsed_menu_object_type_TEE(int id, void * data);
int crsed_menu_object_type_CUP(int id, void * data);
int crsed_menu_object_type_TREE_0(int id, void * data);
int crsed_menu_object_type_TREE_1(int id, void * data);
int crsed_menu_object_type_TREE_2(int id, void * data);
int crsed_menu_object_type_TREE_3(int id, void * data);
int crsed_menu_object_type_ANIMAL_0(int id, void * data);
int crsed_menu_object_type_ANIMAL_1(int id, void * data);
int crsed_menu_object_type_ANIMAL_2(int id, void * data);
int crsed_menu_object_type_HAZARD_WATER(int id, void * data);
int crsed_menu_object_type_HAZARD_SAND(int id, void * data);
int crsed_menu_object_type_HAZARD_ROUGH(int id, void * data);
int crsed_menu_object_type_HAZARD_SLIME(int id, void * data);
int crsed_menu_object_type_PIPE_ENTER(int id, void * data);
int crsed_menu_object_type_PIPE_EXIT(int id, void * data);
int crsed_menu_object_type_HILL(int id, void * data);
int crsed_menu_object_type_RUT(int id, void * data);
int crsed_menu_object_type_POLY_MORPH(int id, void * data);
int crsed_menu_object_type_POLY_MOTION_AREA(int id, void * data);
int crsed_menu_object_type_POLY_MOVE_HORIZ(int id, void * data);
int crsed_menu_object_type_POLY_MOVE_VERT(int id, void * data);
int crsed_menu_object_type_CLOUD_HORIZ(int id, void * data);
int crsed_menu_object_type_CLOUD_VERT(int id, void * data);
int crsed_menu_object_type_LASER_SEND(int id, void * data);
int crsed_menu_object_type_LASER_RECEIVE(int id, void * data);
int crsed_menu_object_type_LASER_RESPAWN(int id, void * data);
int crsed_menu_object_type_TELEPORT(int id, void * data);
int crsed_menu_object_type_CONVEYOR(int id, void * data);
int crsed_menu_object_type_LAYER_TRANSFER(int id, void * data);
int crsed_menu_object_type_TRANSLUCENCY(int id, void * data);
int crsed_menu_object_type_BLINKER(int id, void * data);
int crsed_menu_object_type_DOOR_HORIZ(int id, void * data);
int crsed_menu_object_type_DOOR_VERTICAL(int id, void * data);
int crsed_menu_object_type_DOOR_RESPAWN(int id, void * data);
int crsed_menu_object_type_BUBBLE_HORIZ(int id, void * data);
int crsed_menu_object_type_BUBBLE_VERT(int id, void * data);
int crsed_menu_object_properties_color(int id, void * data);
int crsed_menu_object_properties_connect(int id, void * data);
int crsed_menu_object_properties_set_type(int id, void * data);
int crsed_menu_object_properties_set_angle(int id, void * data);
int crsed_menu_object_properties_set_timer(int id, void * data);
int crsed_menu_object_properties_set_timer2(int id, void * data);
int crsed_menu_object_properties_set_speed(int id, void * data);
int crsed_menu_object_properties_set_size(int id, void * data);
int crsed_menu_object_properties_set_direction(int id, void * data);
int crsed_menu_object_properties_set_target_layer(int id, void * data);
int crsed_menu_object_properties_set_layer(int id, void * data);
int crsed_menu_object_move_up(int id, void * data);
int crsed_menu_object_move_down(int id, void * data);
int crsed_menu_object_delete(int id, void * data);

int crsed_menu_image_type_title(int id, void * data);
int crsed_menu_image_type_scoreboard(int id, void * data);
int crsed_menu_image_type_end_bg(int id, void * data);
int crsed_menu_image_type_end_podium(int id, void * data);
int crsed_menu_image_type_end_cloud_1(int id, void * data);
int crsed_menu_image_type_end_cloud_2(int id, void * data);
int crsed_menu_image_type_1st_trophy(int id, void * data);
int crsed_menu_image_type_2nd_trophy(int id, void * data);
int crsed_menu_image_type_3rd_trophy(int id, void * data);
int crsed_menu_image_type_object_hole(int id, void * data);
int crsed_menu_image_type_object_hole_sunk(int id, void * data);
int crsed_menu_image_type_object_tree_1(int id, void * data);
int crsed_menu_image_type_object_tree_2(int id, void * data);
int crsed_menu_image_type_object_laser_1(int id, void * data);
int crsed_menu_image_type_object_laser_2(int id, void * data);
int crsed_menu_image_type_object_teleport_1(int id, void * data);
int crsed_menu_image_type_object_teleport_2(int id, void * data);
int crsed_menu_image_type_object_conveyor_1(int id, void * data);
int crsed_menu_image_type_object_conveyor_2(int id, void * data);
int crsed_menu_image_type_object_conveyor_3(int id, void * data);
int crsed_menu_image_type_object_conveyor_4(int id, void * data);
int crsed_menu_image_type_object_animal_1_1(int id, void * data);
int crsed_menu_image_type_object_animal_1_2(int id, void * data);
int crsed_menu_image_type_object_animal_1_3(int id, void * data);
int crsed_menu_image_type_object_animal_1_4(int id, void * data);
int crsed_menu_image_type_object_animal_2_1(int id, void * data);
int crsed_menu_image_type_object_animal_2_2(int id, void * data);
int crsed_menu_image_type_object_animal_2_3(int id, void * data);
int crsed_menu_image_type_object_animal_2_4(int id, void * data);
int crsed_menu_image_load(int id, void * data);
int crsed_menu_image_save(int id, void * data);
int crsed_menu_image_clear(int id, void * data);

int crsed_menu_music_choose(int id, void * data);
int crsed_menu_music_remove(int id, void * data);
int crsed_menu_music_listen(int id, void * data);

int crsed_menu_help_manual(int id, void * data);
int crsed_menu_help_about(int id, void * data);

void crsed_post_unsaved_dialog(int id, void * data);

#endif
